diff -ruN ../nakedmudv3.7/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv3.7/src/olc2/redit.c	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/redit.c	2009-03-02 01:00:38.000000000 -0500
@@ -34,6 +34,7 @@
 //*****************************************************************************
 #include "../editor/editor.h"
 #include "../scripts/scripts.h"
+#include "../scripts/pymudsys.h"
 #include "../scripts/script_editor.h"
 
 
@@ -44,6 +45,9 @@
 #ifdef MODULE_TIME
 #include "../time/mudtime.h"
 #endif
+#ifdef MODULE_PERSISTENT
+#include "../persistent/persistent.h"
+#endif
 
 
 
@@ -520,10 +524,12 @@
 		 "{g5) Description\r\n"
 		 "{c%s\r\n"
 		 "{g6) Exits to    : {c%s\r\n"
-		 "{g8) Key         : {c%s\r\n"
-		 "{g7) Closable    : {y[{c%6s{y]%s\r\n"
-		 "{g9) Pick diff   : {y[{c%6d{y]\r\n"
-		 "{g0) Spot diff   : {y[{c%6d{y]\r\n"
+		 "{g7) Key         : {c%s\r\n"
+		 "{g8) Closable    : {y[{c%6s{y]%s\r\n"
+		 "{g9) Closed      : {y[{c%6s{y]\r\n"
+		 "{g0) Locked      : {y[{c%6s{y]\r\n"
+		 "{gP) Pick diff   : {y[{c%6d{y]\r\n"
+		 "{gS) Spot diff   : {y[{c%6d{y]\r\n"
 		 "{gO) Opposite dir: {c%s{n\r\n",
 		 (*exitGetName(exit) ? exitGetName(exit) : "<NONE>"),
 		 (*exitGetKeywords(exit) ? exitGetKeywords(exit) : "<NONE>"),
@@ -532,8 +538,10 @@
 		 exitGetDesc(exit),
 		 exitGetTo(exit),
 		 exitGetKey(exit),
-		 (exitIsClosable(exit) ? "Yes" : "No" ),
+		 YESNO(exitIsClosable(exit)),
 		 (exitIsClosable(exit) && (!*exitGetName(exit) || !*exitGetKeywords(exit)) ? " {r* exit also needs name and keywords{n" : ""),
+		 YESNO(exitIsClosed(exit)),
+		 YESNO(exitIsLocked(exit)),
 		 exitGetPickLev(exit),
 		 exitGetHidden(exit),
 		 (*exitGetOpposite(exit) ? exitGetOpposite(exit) : "<DEFAULT>")
@@ -561,15 +569,23 @@
     text_to_buffer(sock, "Enter a new destination: ");
     return EXEDIT_TO;
   case '7':
-    exitSetClosable(exit, (exitIsClosable(exit) ? FALSE : TRUE));
-    return MENU_NOCHOICE;
-  case '8':
     text_to_buffer(sock, "Enter a new key name: ");
     return EXEDIT_KEY;
+  case '8':
+    exitSetClosable(exit, TOGGLE(exitIsClosable(exit)));
+    return MENU_NOCHOICE;
   case '9':
+    exitSetClosed(exit, TOGGLE(exitIsClosed(exit)));
+    return MENU_NOCHOICE;
+  case '0':
+    exitSetLocked(exit, TOGGLE(exitIsLocked(exit)));
+    if(exitIsLocked(exit))
+      exitSetClosed(exit, TRUE);
+    return MENU_NOCHOICE;
+  case 'P':
     text_to_buffer(sock, "Enter a new lock difficulty: ");
     return EXEDIT_PICK;
-  case '0':
+  case 'S':
     text_to_buffer(sock, "Enter a new spot difficulty: ");
     return EXEDIT_SPOT;
   case 'O':
@@ -640,10 +656,16 @@
   data->abstract   = TRUE;
   data->resettable = FALSE;
   roomSetTerrain(data->room, TERRAIN_NONE);
+
+  // so python olc extensions can get at us
+  room_exist(data->room);
+
   return data;
 }
 
 void deleteRoomOLC(ROOM_OLC *data) {
+  room_unexist(data->room);
+
   if(data->key)        free(data->key);
   if(data->parents)    free(data->parents);
   if(data->room)       deleteRoom(data->room);
@@ -775,8 +797,7 @@
   roomOLCSetAbstract(data, protoIsAbstract(proto));
 
   // build it from the prototype
-  olc_from_proto(proto, roomOLCGetExtraCode(data), room, roomGetPyFormBorrowed,
-		 room_exist, room_unexist);
+  olc_from_proto(proto, roomOLCGetExtraCode(data), room, roomGetPyFormBorrowed);
   bufferFormatFromPy(roomGetDescBuffer(room));
   bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
 
@@ -792,7 +813,7 @@
   deleteListWith(ex_list, free);
 
   // format our extra descriptions
-  if(listSize(edescSetGetList(roomGetEdescs(room))) > 0) {
+  if(edescGetSetSize(roomGetEdescs(room)) > 0) {
     LIST_ITERATOR *edesc_i= newListIterator(edescSetGetList(roomGetEdescs(room)));
     EDESC_DATA      *edesc= NULL;
     ITERATE_LIST(edesc, edesc_i) {
@@ -813,6 +834,10 @@
 void exit_to_proto(EXIT_DATA *exit, BUFFER *buf) {
   if(exitIsClosable(exit))
     bprintf(buf, "exit.makedoor()\n");
+  if(exitIsClosed(exit))
+    bprintf(buf, "exit.close()\n");
+  if(exitIsLocked(exit))
+    bprintf(buf, "exit.lock()\n");
   if(*exitGetName(exit))
     bprintf(buf, "exit.name       = \"%s\"\n", exitGetName(exit));
   if(*exitGetKeywords(exit))
@@ -864,7 +889,7 @@
   }
 
   // extra descriptions
-  if(listSize(edescSetGetList(roomGetEdescs(room))) > 0) {
+  if(edescGetSetSize(roomGetEdescs(room)) > 0) {
     bprintf(buf, "\n### extra descriptions\n");
     LIST_ITERATOR *edesc_i= 
       newListIterator(edescSetGetList(roomGetEdescs(room)));
@@ -1215,6 +1240,10 @@
   // we need a key
   if(!rkey || !*rkey)
     rkey = roomGetClass(charGetRoom(ch));
+  else if(key_malformed(rkey)) {
+    send_to_char(ch, "You entered an invalid content key.\r\n");
+    return;
+  }
 
   char locale[SMALL_BUFFER];
   char   name[SMALL_BUFFER];
@@ -1241,6 +1270,137 @@
   }
 }
 
+bool do_fill(ROOM_DATA *room, const char *dir) {
+#ifdef MODULE_PERSISTENT
+  if(roomIsPersistent(room)) {
+    EXIT_DATA *exit = roomRemoveExit(room, dir);
+    if(exit != NULL) {
+      exit_from_game(exit);
+      deleteExit(exit);
+    }
+
+    // is it a special exit? If so, we may need to remove the command as well
+    if(dirGetNum(dir) == DIR_NONE) {
+      CMD_DATA *cmd = roomRemoveCmd(room, dir);
+      if(cmd != NULL)
+	deleteCmd(cmd);
+    }
+
+    // save our change
+    worldStorePersistentRoom(gameworld, roomGetClass(room), room);
+  }
+  else
+#endif
+    {
+    PROTO_DATA *proto = worldGetType(gameworld, "rproto", roomGetClass(room));
+
+    // parse a room OLC out of it
+    ROOM_OLC *olc = roomOLCFromProto(proto);
+    
+    if(olc == NULL)
+      return FALSE;
+
+    // delete our exits
+    EXIT_DATA *exit = roomRemoveExit(roomOLCGetRoom(olc), dir);
+    if(exit != NULL) {
+      exit_from_game(exit);
+      deleteExit(exit);
+    }
+
+    // is it a special exit? If so, we may need to remove the command as well
+    if(dirGetNum(dir) == DIR_NONE) {
+      CMD_DATA *cmd = roomRemoveCmd(room, dir);
+      if(cmd != NULL)
+	deleteCmd(cmd);
+    }
+
+    // add in our resets so they don't get wiped during saving
+    RESET_LIST  *resets = worldGetType(gameworld, "reset", roomGetClass(room));
+    if(resets != NULL)
+      resetListCopyTo(resets, roomOLCGetResets(olc));
+    if(listGetWith(zoneGetResettable(worldGetZone(gameworld, get_key_locale(roomGetClass(room)))),
+		   get_key_name(roomGetClass(room)),
+		   strcasecmp) != NULL)
+      roomOLCSetResettable(olc, TRUE);
+
+    // save our changes and reload the room
+    save_room_olc(olc);
+
+    // garbage collection
+    deleteRoomOLC(olc);
+  }
+
+  return TRUE;
+}
+
+bool do_dig(ROOM_DATA *from, ROOM_DATA *to, const char *dir) {
+#ifdef MODULE_PERSISTENT
+  // are we in a persistent room?
+  if(roomIsPersistent(from)) {
+    EXIT_DATA *exit = newExit();
+    exitSetTo(exit, roomGetClass(to));
+    roomSetExit(from, dir, exit);
+    exit_to_game(exit);
+
+    // if it is a special exit and we have a registered movement command,
+    // add a special command to the room to use this exit
+    if(dirGetNum(dir) == DIR_NONE && get_cmd_move() != NULL) {
+      CMD_DATA *cmd = newPyCmd(dir, get_cmd_move(), "player", TRUE);
+
+      // add all of our movement checks
+      LIST_ITERATOR *chk_i = newListIterator(get_move_checks());
+      PyObject        *chk = NULL;
+      ITERATE_LIST(chk, chk_i) {
+	cmdAddPyCheck(cmd, chk);
+      } deleteListIterator(chk_i);
+
+      //cmdAddCheck(cmd, chk_can_move);
+      roomAddCmd(from, dir, NULL, cmd);
+    }
+      
+    // save our change
+    worldStorePersistentRoom(gameworld, roomGetClass(from), from);
+  }
+
+  // load up the rproto and edit it
+  else
+#endif
+    {
+    // get the prototype for our current room
+    PROTO_DATA *proto = 
+      worldGetType(gameworld, "rproto", roomGetClass(from));
+
+    // parse a ROOM_OLC out of it
+    ROOM_OLC *olc = roomOLCFromProto(proto);
+
+    // error occured
+    if(olc == NULL)
+      return FALSE;
+
+    // make our exits
+    EXIT_DATA  *exit = newExit();
+    exitSetTo(exit, roomGetClass(to));
+
+    // link our rooms
+    roomSetExit(roomOLCGetRoom(olc), dir, exit);
+
+    // re-update our resets
+    RESET_LIST  *resets = 
+      worldGetType(gameworld, "reset", roomGetClass(from));
+    if(resets != NULL)
+      resetListCopyTo(resets, roomOLCGetResets(olc));
+    if(listGetWith(zoneGetResettable(worldGetZone(gameworld, get_key_locale(roomGetClass(from)))),
+		   get_key_name(roomGetClass(from)),
+		   strcasecmp) != NULL)
+      roomOLCSetResettable(olc, TRUE);
+    
+    // save our changes and reload the rooms
+    save_room_olc(olc);
+    deleteRoomOLC(olc);
+  }
+
+  return TRUE;
+}
 
 COMMAND(cmd_dig) {
   ROOM_DATA      *dest = NULL;
@@ -1269,17 +1429,13 @@
   else if(dirGetAbbrevNum(dir) != DIR_NONE)
     ret_dir = strdup(dirGetName(dirGetOpposite(dirGetAbbrevNum(dir))));
 
-  // make sure we have a return direction
-  if(ret_dir == NULL)
-    send_to_char(ch, "A return direction for the dig could not be found.\r\n");
-
   // make sure we don't have an exit in the specified direction
-  else if(roomGetExit(charGetRoom(ch), dir) != NULL)
+  if(roomGetExit(charGetRoom(ch), dir) != NULL)
     send_to_char(ch, "An exit already exists %s -- fill it first!\r\n",
 		 dir);
 
   // make sure we don't have an exit in the return direction
-  else if(roomGetExit(dest, ret_dir) != NULL)
+  else if(ret_dir && roomGetExit(dest, ret_dir) != NULL)
     send_to_char(ch, "An exit already exists in the return direction -- fill it first!\r\n");
 
   // make sure we have edit priviledges
@@ -1292,38 +1448,21 @@
 
   // do the digging
   else {
-    // get the prototype for our current room and destination
-    PROTO_DATA  *proto_here = 
-      worldGetType(gameworld, "rproto", roomGetClass(charGetRoom(ch)));
-    PROTO_DATA *proto_there = 
-      worldGetType(gameworld, "rproto", roomGetClass(dest));
-
-    // parse a ROOM_OLC out of them both
-    ROOM_OLC  *olc_here = roomOLCFromProto(proto_here);
-    ROOM_OLC *olc_there = roomOLCFromProto(proto_there);
-
-    // make our exits
-    EXIT_DATA  *exit_here = newExit();
-    EXIT_DATA *exit_there = newExit();
-    exitSetTo(exit_here, roomGetClass(dest));
-    exitSetTo(exit_there, roomGetClass(charGetRoom(ch)));
-
-    // link our rooms
-    roomSetExit(roomOLCGetRoom(olc_here), dir, exit_here);
-    roomSetExit(roomOLCGetRoom(olc_there), ret_dir, exit_there);
-
-    // save our changes and reload the rooms
-    save_room_olc(olc_here);
-    save_room_olc(olc_there);
-
-    // garbage collection
-    deleteRoomOLC(olc_here);
-    deleteRoomOLC(olc_there);
+    if(do_dig(charGetRoom(ch), dest, dir))
+      send_to_char(ch, "You link %s to %s [%s].\r\n",
+		   roomGetClass(charGetRoom(ch)), roomGetClass(dest), dir);
+    else {
+      send_to_char(ch, "An error occured while digging to %s.",
+		   roomGetClass(dest));
+    }
 
-    // inform the builder
-    send_to_char(ch, "You link %s [%s] to %s [%s].\r\n",
-		 roomGetClass(charGetRoom(ch)), dir,
-		 roomGetClass(dest), ret_dir);
+    if(ret_dir && do_dig(dest, charGetRoom(ch), ret_dir))
+      send_to_char(ch, "You link %s to %s [%s].\r\n",
+		   roomGetClass(dest), roomGetClass(charGetRoom(ch)), ret_dir);
+    else if(ret_dir) {
+      send_to_char(ch, "An error occured while digging a return to %s.",
+		   roomGetClass(charGetRoom(ch)));
+    }
   }
 
   // garbage collection
@@ -1358,15 +1497,12 @@
   else if(dirGetAbbrevNum(dir) != DIR_NONE)
     ret_dir = strdup(dirGetName(dirGetOpposite(dirGetAbbrevNum(dir))));
 
-  // make sure we have a return direction
-  if(ret_dir == NULL)
-    send_to_char(ch, "A return direction for fill could not be found.\r\n");
   // make sure we have the exit
-  else if(!roomGetExit(charGetRoom(ch), dir))
+  if(!roomGetExit(charGetRoom(ch), dir))
     send_to_char(ch, "No exit exists %s!\r\n", dir);
   // make sure the destination exists
-  else if((dest = worldGetRoom(gameworld,exitGetTo(roomGetExit(charGetRoom(ch),
-							       dir)))) == NULL)
+  else if((dest = worldGetRoom(gameworld,exitGetToFull(roomGetExit(charGetRoom(ch),
+								   dir)))) == NULL)
     send_to_char(ch, "No destination exists %s!\r\n", dir);
   // make sure we have edit priviledges
   else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(charGetRoom(ch)))), ch))
@@ -1375,34 +1511,22 @@
   else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(dest))), ch))
     send_to_char(ch,"You are not authorized to edit the destination zone.\r\n");
 
-  // do the digging
+  // do the filling
   else {
-    // get the prototype for our current room and destination
-    PROTO_DATA  *proto_here = 
-      worldGetType(gameworld, "rproto", roomGetClass(charGetRoom(ch)));
-    PROTO_DATA *proto_there = 
-      worldGetType(gameworld, "rproto", roomGetClass(dest));
-
-    // parse a ROOM_OLC out of them both
-    ROOM_OLC  *olc_here = roomOLCFromProto(proto_here);
-    ROOM_OLC *olc_there = roomOLCFromProto(proto_there);
-
-    // delete our exits
-    roomRemoveExit(roomOLCGetRoom(olc_here), dir);
-    roomRemoveExit(roomOLCGetRoom(olc_there), ret_dir);
-
-    // save our changes and reload the rooms
-    save_room_olc(olc_here);
-    save_room_olc(olc_there);
-
-    // garbage collection
-    deleteRoomOLC(olc_here);
-    deleteRoomOLC(olc_there);
+    if(do_fill(charGetRoom(ch), dir))
+      send_to_char(ch, "You unlink %s [%s].\r\n", 
+		   roomGetClass(charGetRoom(ch)), dir);
+    else {
+      send_to_char(ch, "An error occured while filling %s %s.", 
+		   roomGetClass(charGetRoom(ch)), dir);
+    }
 
-    // inform the builder
-    send_to_char(ch, "You unlink %s [%s] and %s [%s].\r\n",
-		 roomGetClass(charGetRoom(ch)), dir,
-		 roomGetClass(dest), ret_dir);
+    if(ret_dir && do_fill(dest, ret_dir))
+      send_to_char(ch, "You unlink %s [%s].\r\n", roomGetClass(dest), ret_dir);
+    else if(ret_dir) {
+      send_to_char(ch, "An error occured while filling %s %s.", 
+		   roomGetClass(dest), ret_dir);
+    }
   }
 
   // garbage collection
@@ -1477,6 +1601,8 @@
   // get our locale and name for the dest
   else if(!parse_worldkey_relative(ch, dest, dest_name, dest_locale))
     send_to_char(ch, "What is the key of the destination room?\r\n");
+  else if(key_malformed(src) || key_malformed(dest))
+    send_to_char(ch, "Malformed source or destination keys.");
   // make sure the destination zone is editable
   else if((dest_zone = worldGetZone(gameworld, dest_locale)) == NULL)
     send_to_char(ch, "No such destination zone exists.\r\n");
@@ -1527,6 +1653,10 @@
   // we need a key
   if(!rkey || !*rkey)
     rkey = roomGetClass(charGetRoom(ch));
+  else if(key_malformed(rkey)) {
+    send_to_char(ch, "You entered an invalid content key.\r\n");
+    return;
+  }
 
   char locale[SMALL_BUFFER];
   char   name[SMALL_BUFFER];
diff -ruN ../nakedmudv3.7/src/olc2/zedit.c src/olc2/zedit.c
--- ../nakedmudv3.7/src/olc2/zedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/zedit.c	2009-03-02 01:00:38.000000000 -0500
@@ -156,12 +156,19 @@
 COMMAND(cmd_zedit) {
   // we want to create a new zone?
   if(!strncasecmp(arg, "new ", 4)) {
+    if(!bitIsSet(charGetUserGroups(ch), "admin")) {
+      send_to_char(ch, "You are not authorized to create new zones.\r\n");
+      return;
+    }
+
     char key[100];
 
     // scan for the parameters
     sscanf(arg+4, "%s", key);
 
-    if(worldGetZone(gameworld, key))
+    if(locale_malformed(key))
+      send_to_char(ch, "The zone name you entered was malformed.");
+    else if(worldGetZone(gameworld, key))
       send_to_char(ch, "A zone already exists with that key.\r\n");
     else {
       char buf[MAX_BUFFER];
@@ -179,6 +186,8 @@
   }
 
   // we want to edit a preexisting zone
+  else if(locale_malformed(arg))
+    send_to_char(ch, "The zone name you entered was malformed.");
   else {
     ZONE_DATA *zone = 
       (*arg ? worldGetZone(gameworld, arg) : 
diff -ruN ../nakedmudv3.7/src/parse.c src/parse.c
--- ../nakedmudv3.7/src/parse.c	2008-12-06 00:20:20.000000000 -0500
+++ src/parse.c	2009-03-02 01:00:39.000000000 -0500
@@ -68,8 +68,9 @@
   token->type = type;
   if(type == PARSE_TOKEN_MULTI)
     token->token_list = newList();
-  else if(type == PARSE_TOKEN_OBJ)
+  else if(type == PARSE_TOKEN_OBJ) {
     SET_BIT(token->scope, FIND_SCOPE_VISIBLE);
+  }
   else if(type == PARSE_TOKEN_EXIT) {
     SET_BIT(token->scope, FIND_SCOPE_VISIBLE);
     SET_BIT(token->scope, FIND_SCOPE_ROOM);
@@ -81,6 +82,16 @@
   return token;
 }
 
+PARSE_TOKEN *newParseTokenDescriptive(int type, const char *format) {
+  PARSE_TOKEN *token = newParseToken(type);
+  // do we have a describer between ( and )?
+  if(endswith(format, ")") && strchr(format, '(')) {
+    format = format + next_letter_in(format, '(') + 1;
+    token->flavor = strdup(format);
+    token->flavor[strlen(token->flavor)-1] = '\0';
+  }
+  return token;
+}
 
 //
 // free a token from memory
@@ -135,7 +146,7 @@
 // makes a char token, and parses options. Returns NULL if there's bad options
 PARSE_TOKEN *parse_token_char(const char *options) {
   // make it
-  PARSE_TOKEN *token = newParseToken(PARSE_TOKEN_CHAR);
+  PARSE_TOKEN *token = newParseTokenDescriptive(PARSE_TOKEN_CHAR, options);
 
   // search for options
   while(*options != '\0') {
@@ -159,6 +170,8 @@
       options = options + 9;
       REMOVE_BIT(token->scope, FIND_SCOPE_VISIBLE);
     }
+    else if(*options == '(' && endswith(options, ")"))
+      break;
     // didn't recognize the option
     else {
       deleteParseToken(token);
@@ -181,7 +194,7 @@
 // makes an obj token, and parses options. Returns NULL if there's bad options
 PARSE_TOKEN *parse_token_obj(const char *options) {
   // make it
-  PARSE_TOKEN *token = newParseToken(PARSE_TOKEN_OBJ);
+  PARSE_TOKEN *token = newParseTokenDescriptive(PARSE_TOKEN_OBJ, options);
 
   // search for options
   while(*options != '\0') {
@@ -209,6 +222,8 @@
       options = options + 9;
       REMOVE_BIT(token->scope, FIND_SCOPE_VISIBLE);
     }
+    else if(*options == '(' && endswith(options, ")"))
+      break;
     // didn't recognize the option
     else {
       deleteParseToken(token);
@@ -232,7 +247,7 @@
 // makes an exit token, and parses options. Returns NULL if there's bad options
 PARSE_TOKEN *parse_token_exit(const char *options) {
   // make it
-  PARSE_TOKEN *token = newParseToken(PARSE_TOKEN_EXIT);
+  PARSE_TOKEN *token = newParseTokenDescriptive(PARSE_TOKEN_EXIT, options);
 
   // search for options
   while(*options != '\0') {
@@ -244,6 +259,8 @@
       options = options + 9;
       REMOVE_BIT(token->scope, FIND_SCOPE_VISIBLE);
     }
+    else if(*options == '(' && endswith(options, ")"))
+      break;
     // didn't recognize the option
     else {
       deleteParseToken(token);
@@ -266,23 +283,24 @@
   int i = 0;
 
   // copy what we're trying to parse
-  for(i = 0; isalpha(*fmt) || *fmt == '_' || *fmt == '.'; i++, fmt++)
+  for(i = 0; isalpha(*fmt) || (strchr("_.()", *fmt) && *fmt); i++, fmt++)
+    // *fmt == '_' || *fmt == '.'; i++, fmt++)
     buf[i] = *fmt;
   buf[i] = '\0';
 
   // figure out our type
-  if(!strcasecmp(buf, "int"))
-    token = newParseToken(PARSE_TOKEN_INT);
-  else if(!strcasecmp(buf, "double"))
-    token = newParseToken(PARSE_TOKEN_DOUBLE);
-  else if(!strcasecmp(buf, "bool"))
-    token = newParseToken(PARSE_TOKEN_BOOL);
-  else if(!strcasecmp(buf, "word"))
-    token = newParseToken(PARSE_TOKEN_WORD);
-  else if(!strcasecmp(buf, "string"))
-    token = newParseToken(PARSE_TOKEN_STRING);
-  else if(!strcasecmp(buf, "room"))
-    token = newParseToken(PARSE_TOKEN_ROOM);
+  if(startswith(buf, "int"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_INT, buf);
+  else if(startswith(buf, "double"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_DOUBLE, buf);
+  else if(startswith(buf, "bool"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_BOOL, buf);
+  else if(startswith(buf, "word"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_WORD, buf);
+  else if(startswith(buf, "string"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_STRING, buf);
+  else if(startswith(buf, "room"))
+    token = newParseTokenDescriptive(PARSE_TOKEN_ROOM, buf);
 
   // exits, chars, and objs can have arguments tagged to the end of them. For
   // exits, it is optional. For both chars and objs, it is neccessary to specify
@@ -576,8 +594,8 @@
 PARSE_VAR *use_one_parse_token_char(CHAR_DATA *looker, PARSE_TOKEN *tok,
 				    const char *name) {
   int    type = FOUND_NONE;
-  void *found = generic_find(looker, name, FIND_TYPE_CHAR, tok->scope,
-			     tok->all_ok, &type);
+  void *found = find_specific(looker, name, "", "", FIND_TYPE_CHAR, tok->scope,
+			      tok->all_ok, &type);
 
   // make sure we found something...
   if(found == NULL)
@@ -633,8 +651,8 @@
 PARSE_VAR *use_one_parse_token_obj(CHAR_DATA *looker, PARSE_TOKEN *tok,
 				   const char *name) {
   int    type = FOUND_NONE;
-  void *found = generic_find(looker, name, FIND_TYPE_OBJ, tok->scope,
-			     tok->all_ok, &type);
+  void *found = find_specific(looker, name, "", "", FIND_TYPE_OBJ, tok->scope,
+			      tok->all_ok, &type);
 
   // make sure we found something
   if(found == NULL)
@@ -683,8 +701,8 @@
 PARSE_VAR *use_one_parse_token_exit(CHAR_DATA *looker, PARSE_TOKEN *tok, 
 				    const char *name) {
   int    type = FOUND_NONE;
-  void *found = generic_find(looker, name, FIND_TYPE_EXIT, tok->scope,
-			     tok->all_ok, &type);
+  void *found = find_specific(looker, name, "", "", FIND_TYPE_EXIT, tok->scope,
+			      tok->all_ok, &type);
 
   // make sure we found something
   if(found == NULL)
@@ -732,8 +750,8 @@
 // tries to make a room parse var
 PARSE_VAR *use_one_parse_token_room(CHAR_DATA *looker, PARSE_TOKEN *tok,
 				    const char *name) {
-  ROOM_DATA *room = generic_find(looker, name, FIND_TYPE_ROOM, FIND_SCOPE_WORLD,
-				 FALSE, NULL);
+  ROOM_DATA *room = find_specific(looker, name, "", "", FIND_TYPE_ROOM, 
+				  FIND_SCOPE_WORLD, FALSE, NULL);
 
   // did we find something?
   if(room == NULL)
@@ -825,7 +843,7 @@
     arg = one_arg(arg, buf);
     var = use_one_parse_token_char(looker, tok, buf);
     if(var == NULL) {
-      sprintf(err_buf, "Could not find person, '%s'.", buf);
+      sprintf(err_buf, "The person, %s, could not be found.", buf);
       *error = TRUE;
     }
     break;
@@ -835,7 +853,7 @@
     arg = one_arg(arg, buf);
     var = use_one_parse_token_obj(looker, tok, buf);
     if(var == NULL) {
-      sprintf(err_buf, "Could not find object, '%s'.", buf);
+      sprintf(err_buf, "The object, %s, could not be found.", buf);
       *error = TRUE;
     }
     break;
@@ -845,7 +863,7 @@
     arg = one_arg(arg, buf);
     var = use_one_parse_token_room(looker, tok, buf);
     if(var == NULL) {
-      sprintf(err_buf, "Could not find room, '%s'.", buf);
+      sprintf(err_buf, "The room, %s, could not be found.", buf);
       *error = TRUE;
     }
     break;
@@ -855,7 +873,7 @@
     arg = one_arg(arg, buf);
     var = use_one_parse_token_exit(looker, tok, buf);
     if(var == NULL) {
-      sprintf(err_buf, "Could not find door or direction named '%s'.", buf);
+      sprintf(err_buf, "The direction, %s, could not be found.", buf);
       *error = TRUE;
     }
     break;
@@ -942,6 +960,9 @@
 //
 // gets the name of the type for printing in syntax error messages
 const char *get_datatype_format_error_mssg(PARSE_TOKEN *tok) {
+  if(tok->flavor)
+    return tok->flavor;
+
   switch(tok->type) {
   case PARSE_TOKEN_CHAR:
     return "person";
diff -ruN ../nakedmudv3.7/src/prototype.c src/prototype.c
--- ../nakedmudv3.7/src/prototype.c	2008-12-06 00:20:20.000000000 -0500
+++ src/prototype.c	2009-03-02 01:00:39.000000000 -0500
@@ -138,8 +138,9 @@
   return data->script;
 }
 
-bool protoRun(PROTO_DATA *proto, const char *type, void *pynewfunc, 
-	      void *protoaddfunc, void *protoclassfunc, void *me) {
+bool protoRunAs(PROTO_DATA *proto, const char *type, const char *as, 
+		void *pynewfunc, void *protoaddfunc, void *protoclassfunc, 
+		void *me) {
   // parse and run all of our parents
   LIST           *parents = parse_keywords(proto->parents);
   LIST_ITERATOR *parent_i = newListIterator(parents);
@@ -183,18 +184,18 @@
   if(protoaddfunc)
     ((void (*)(void *, const char *))protoaddfunc)(me, protoGetKey(proto));
   if(protoclassfunc)
-    ((void (*)(void *, const char *))protoclassfunc)(me, protoGetKey(proto));
+    ((void (*)(void *, const char *))protoclassfunc)(me, as);
 
   PyDict_SetItemString(dict, "me", pyme);
 
   // do we have our own code already, or do we need to compile from source?
   if(proto->code == NULL) {
-    proto->code = run_script_forcode(dict, bufferString(proto->script),
-				     get_key_locale(protoGetKey(proto)));
+    proto->code = run_script_forcode(dict, bufferString(proto->script), 
+				     get_key_locale(as));
   }
   // we already have a code object. Evaluate it.
   else {
-    run_code(proto->code, dict, get_key_locale(protoGetKey(proto)));
+    run_code(proto->code, dict, get_key_locale(as));
     
     if(!last_script_ok())
       log_pyerr("Prototype %s terminated with an error:\r\n%s",
@@ -206,17 +207,24 @@
   PyDict_DelItemString(dict, "me");
   // PyDict_SetItemString(dict, "me", Py_None);
 
+  // garbage collection
   Py_DECREF(dict);
-  Py_DECREF(pyme);
+  // Py_DECREF(pyme);
   return last_script_ok();
 }
 
+bool protoRun(PROTO_DATA *proto, const char *type, void *pynewfunc, 
+	      void *protoaddfunc, void *protoclassfunc, void *me) {
+  const char *as = protoGetKey(proto);
+  return protoRunAs(proto,type,as,pynewfunc,protoaddfunc,protoclassfunc,me);
+}
+
 CHAR_DATA *protoMobRun(PROTO_DATA *proto) {
   if(protoIsAbstract(proto))
     return NULL;
   CHAR_DATA *ch = newMobile();
   char_exist(ch);
-  if(protoRun(proto, "mproto", charGetPyForm, charAddPrototype, charSetClass, ch))
+  if(protoRun(proto, "mproto", charGetPyFormBorrowed, charAddPrototype, charSetClass, ch))
     char_to_game(ch);
   else {
     // should this be char_unexist? Check to see what difference it makes
@@ -232,7 +240,7 @@
     return NULL;
   OBJ_DATA *obj = newObj();
   obj_exist(obj);
-  if(protoRun(proto, "oproto", newPyObj, objAddPrototype, objSetClass, obj))
+  if(protoRun(proto, "oproto", objGetPyFormBorrowed, objAddPrototype, objSetClass, obj))
     obj_to_game(obj);
   else {
     // should this be obj_unexist? Check to see what difference it makes
@@ -248,7 +256,7 @@
     return NULL;
   ROOM_DATA *room = newRoom();
   room_exist(room);
-  if(protoRun(proto, "rproto", newPyRoom, roomAddPrototype,roomSetClass,room))
+  if(protoRun(proto, "rproto", roomGetPyFormBorrowed, roomAddPrototype,roomSetClass,room))
     room_to_game(room);
   else {
     // should this be room_unexist? Check to see what difference it makes
@@ -258,3 +266,22 @@
 
   return room;
 }
+
+ROOM_DATA *protoRoomInstance(PROTO_DATA *proto, const char *as) {
+  if(protoIsAbstract(proto))
+    return NULL;
+  ROOM_DATA *room = newRoom();
+  room_exist(room);
+  if(protoRun(proto, "rproto", roomGetPyFormBorrowed, roomAddPrototype, 
+	      roomSetClass, room)) {
+    roomSetClass(room, as);
+    room_to_game(room);
+  }
+  else {
+    // should this be room_unexist? Check to see what difference it makes
+    extract_room(room);
+    room = NULL;
+  }
+
+  return room;
+}
diff -ruN ../nakedmudv3.7/src/prototype.h src/prototype.h
--- ../nakedmudv3.7/src/prototype.h	2008-05-31 00:17:59.000000000 -0400
+++ src/prototype.h	2009-03-02 01:00:39.000000000 -0500
@@ -21,7 +21,7 @@
 CHAR_DATA  *protoMobRun(PROTO_DATA *proto);
 OBJ_DATA   *protoObjRun(PROTO_DATA *proto);
 ROOM_DATA *protoRoomRun(PROTO_DATA *proto);
-
+ROOM_DATA *protoRoomInstance(PROTO_DATA *proto, const char *as);
 
 //
 // setters
diff -ruN ../nakedmudv3.7/src/races.c src/races.c
--- ../nakedmudv3.7/src/races.c	2008-05-31 00:17:59.000000000 -0400
+++ src/races.c	2009-03-02 01:00:39.000000000 -0500
@@ -23,7 +23,7 @@
 //*****************************************************************************
 
 // how big is hour hashtable for holding race data?
-#define RACE_TABLE_SIZE    10
+#define RACE_TABLE_SIZE    55
 HASHTABLE *race_table = NULL;
 
 
@@ -40,7 +40,7 @@
   RACE_DATA *data = malloc(sizeof(RACE_DATA));
   data->name   = strdupsafe(name);
   data->abbrev = strdupsafe(abbrev);
-  data->body   = body;
+  data->body   = bodyCopy(body);
   data->pc_ok  = pc_ok;
   return data;
 }
